package dev.shadowsoffire.apotheosis.mixin;

import javax.annotation.Nullable;
import dev.shadowsoffire.apotheosis.util.INBTSensitiveFallingBlock;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.item.FallingBlockEntity;
import org.spongepowered.asm.mixin.Mixin;
import net.minecraft.world.entity.Entity;

@Mixin({ FallingBlockEntity.class })
public abstract class FallingBlockEntityMixin extends Entity
{
    public FallingBlockEntityMixin(final EntityType<?> pType, final Level pLevel) {
        super((EntityType)pType, pLevel);
    }
    
    @Nullable
    public ItemEntity m_19998_(final ItemLike pItem) {
        if (pItem instanceof final INBTSensitiveFallingBlock nbtSensitive) {
            if (this.ths().f_31944_ != null) {
                return this.ths().m_5552_(nbtSensitive.toStack(this.ths().m_31980_(), this.ths().f_31944_), 0.0f);
            }
        }
        return this.ths().m_20000_(pItem, 0);
    }
    
    private FallingBlockEntity ths() {
        return (FallingBlockEntity)this;
    }
}
